> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dfns.co/llms.txt
> Use this file to discover all available pages before exploring further.

# List Swaps

> List all swaps with pagination

#### Authentication

✅ Organization User (`CustomerEmployee`)\
❌ Delegated User (`EndUser`)\
✅ Service Account

#### Required Permissions

`Swaps:Read`: Always required.


## OpenAPI

````yaml /openapi.yaml get /swaps
openapi: 3.1.0
info:
  version: 1.795.3
  title: Dfns
servers:
  - url: https://api.dfns.io
    description: Default - Europe
  - url: https://api.uae.dfns.io
    description: UAE
  - url: https://api.dfns.ninja
    description: <Deprecated> Staging
security: []
paths:
  /swaps:
    get:
      tags:
        - Swaps
      summary: List Swaps
      description: List all swaps with pagination
      parameters:
        - schema:
            type: integer
            minimum: 1
            maximum: 500
            default: 50
            description: Maximum number of items to return.
          required: false
          description: Maximum number of items to return.
          name: limit
          in: query
        - schema:
            type: string
            minLength: 1
            description: >-
              Opaque token used to retrieve the next page. Returned as
              `nextPageToken` from the previous request.
          required: false
          description: >-
            Opaque token used to retrieve the next page. Returned as
            `nextPageToken` from the previous request.
          name: paginationToken
          in: query
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/Swap'
                    description: Current page items.
                  nextPageToken:
                    type: string
                    description: >-
                      token to use as `paginationToken` to request the next
                      page.
                required:
                  - items
      security:
        - authenticationToken: []
components:
  schemas:
    Swap:
      type: object
      properties:
        id:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^swap-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: Swap id.
          example: swap-5ch70-fc3n7-3k2cbo8d7q5lnts4
        quoteId:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^swapQuote-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: Id of the quote this swap is based on.
          example: swapQuote-7n9p0-cth75-6l74n2sj7u73ooeq
        reference:
          type:
            - string
            - 'null'
          description: Optional user-defined reference for this Swap.
        walletId:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^wa-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: Id of the Dfns wallet spending the sourceAsset.
          example: wa-5pfuu-9euek-h0odgb6snva8ph3k
        targetWalletId:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^wa-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: >-
            Id of the Dfns wallet receiving the target asset. Currently this
            value must be the same as the `walletId`.
          example: wa-5pfuu-9euek-h0odgb6snva8ph3k
        status:
          type: string
          enum:
            - PendingPolicyApproval
            - InProgress
            - Completed
            - Failed
            - Rejected
          description: Swap status.
        provider:
          type: string
          enum:
            - UniswapX
            - UniswapClassic
          description: Swap provider.
        quotedSourceAsset:
          allOf:
            - oneOf:
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - Native
                    amount:
                      type: string
                      pattern: ^\d+$
                  required:
                    - kind
                    - amount
                  title: Native Asset
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - Erc20
                    contract:
                      type: string
                      pattern: ^0x[0-9a-fA-F]{40}$
                    amount:
                      type: string
                      pattern: ^\d+$
                  required:
                    - kind
                    - contract
                    - amount
                  title: EVM Fungible Token (ERC-20)
            - type: object
              properties:
                metadata:
                  type: object
                  properties:
                    network:
                      $ref: '#/components/schemas/Network'
                    name:
                      type: string
                    symbol:
                      type: string
                    decimals:
                      type: number
                    tid:
                      type: string
                  required:
                    - network
                    - decimals
              required:
                - metadata
          description: The source asset for this swap transaction.
        quotedTargetAsset:
          allOf:
            - oneOf:
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - Native
                    amount:
                      type: string
                      pattern: ^\d+$
                  required:
                    - kind
                    - amount
                  title: Native Asset
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - Erc20
                    contract:
                      type: string
                      pattern: ^0x[0-9a-fA-F]{40}$
                    amount:
                      type: string
                      pattern: ^\d+$
                  required:
                    - kind
                    - contract
                    - amount
                  title: EVM Fungible Token (ERC-20)
            - type: object
              properties:
                metadata:
                  type: object
                  properties:
                    network:
                      $ref: '#/components/schemas/Network'
                    name:
                      type: string
                    symbol:
                      type: string
                    decimals:
                      type: number
                    tid:
                      type: string
                  required:
                    - network
                    - decimals
              required:
                - metadata
          description: The target asset for this swap transaction.
        slippageBps:
          type: number
          description: >-
            The slippage tolerance for this trade in [basis
            point](https://en.wikipedia.org/wiki/Basis_point) (BPS). Slippage
            tolerance defines the maximum price difference you are willing to
            accept during a trade from the estimated quote, ensuring you still
            receive at least a minimum number of tokens if the price shifts. One
            basis point equals one-hundredth of a percentage point, or 0.01%.
        dateCreated:
          type: string
          format: date-time
          description: >-
            [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) date (must be
            UTC). When the swap was initiated.
        requestBody:
          anyOf:
            - type: object
              properties:
                quoteId:
                  type: string
                  minLength: 1
                  maxLength: 64
                  pattern: ^swapQuote-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
                  description: Quote to use for this swap.
                  example: swapQuote-7n9p0-cth75-6l74n2sj7u73ooeq
                reference:
                  type: string
                  description: An optional reference for this Swap.
                provider:
                  type: string
                  enum:
                    - UniswapX
                    - UniswapClassic
                  description: >-
                    Provided for this swap. Used for attesting that the swap is
                    being created with the same parameters as the quote.
                walletId:
                  type: string
                  minLength: 1
                  maxLength: 64
                  pattern: ^wa-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
                  description: >-
                    Id of the Dfns wallet spending the sourceAsset. Used for
                    attesting that the swap is being created with the same
                    parameters as the quote.
                  example: wa-5pfuu-9euek-h0odgb6snva8ph3k
                targetWalletId:
                  type: string
                  minLength: 1
                  maxLength: 64
                  pattern: ^wa-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
                  description: >-
                    Id of the Dfns wallet receiving the target asset. Currently
                    this value must be the same as the `walletId`. Used for
                    attesting that the swap is being created with the same
                    parameters as the quote.
                  example: wa-5pfuu-9euek-h0odgb6snva8ph3k
                slippageBps:
                  type: number
                  description: >-
                    The slippage tolerance for this trade in [basis
                    point](https://en.wikipedia.org/wiki/Basis_point) (BPS).
                    Slippage tolerance defines the maximum price difference you
                    are willing to accept during a trade from the estimated
                    quote, ensuring you still receive at least a minimum number
                    of tokens if the price shifts. One basis point equals
                    one-hundredth of a percentage point, or 0.01%. Used for
                    attesting that the swap is being created with the same
                    parameters as the quote. 
                sourceAsset:
                  oneOf:
                    - type: object
                      properties:
                        kind:
                          type: string
                          enum:
                            - Native
                        amount:
                          type: string
                          pattern: ^\d+$
                      required:
                        - kind
                        - amount
                      title: Native Asset
                    - type: object
                      properties:
                        kind:
                          type: string
                          enum:
                            - Erc20
                        contract:
                          type: string
                          pattern: ^0x[0-9a-fA-F]{40}$
                        amount:
                          type: string
                          pattern: ^\d+$
                      required:
                        - kind
                        - contract
                        - amount
                      title: EVM Fungible Token (ERC-20)
                  description: >-
                    The source asset that will be spent on the Swap transaction.
                    Used for attesting that the swap is being created with the
                    same parameters as the quote.
                targetAsset:
                  oneOf:
                    - type: object
                      properties:
                        kind:
                          type: string
                          enum:
                            - Native
                        amount:
                          type: string
                          pattern: ^\d+$
                      required:
                        - kind
                        - amount
                      title: Native Asset
                    - type: object
                      properties:
                        kind:
                          type: string
                          enum:
                            - Erc20
                        contract:
                          type: string
                          pattern: ^0x[0-9a-fA-F]{40}$
                        amount:
                          type: string
                          pattern: ^\d+$
                      required:
                        - kind
                        - contract
                        - amount
                      title: EVM Fungible Token (ERC-20)
                  description: >-
                    The target asset that will be received with the Swap
                    transaction. Used for attesting that the swap is being
                    created with the same parameters as the quote.
              required:
                - quoteId
                - provider
                - walletId
                - slippageBps
                - sourceAsset
                - targetAsset
            - type: object
              properties: {}
          description: The full request used for initiating this swap.
        requester:
          $ref: '#/components/schemas/Requester'
        failureReason:
          type: string
          description: The failure reason, if any. Only present when status is Failed.
      required:
        - id
        - quoteId
        - reference
        - walletId
        - targetWalletId
        - status
        - provider
        - quotedSourceAsset
        - quotedTargetAsset
        - slippageBps
        - dateCreated
        - requestBody
        - requester
      example:
        id: swap-6a3ku-bn8d7-8u5rs1oukojms7k8
        quoteId: swapQuote-3hgv4-q8tbf-8v2ajmrbmg6m4i9t
        reference: null
        walletId: wa-3l3cj-l8mq7-8q78f9nopq7f1qjv
        targetWalletId: wa-3l3cj-l8mq7-8q78f9nopq7f1qjv
        status: PendingPolicyApproval
        provider: UniswapClassic
        quotedSourceAsset:
          kind: Native
          amount: '10000000000'
          metadata:
            network: EthereumSepolia
            name: Ethereum
            symbol: SepoliaETH
            decimals: 18
            tid: native:eth
        quotedTargetAsset:
          kind: Erc20
          contract: '0xda0be7efd234295395d4204d0df4358339b57b27'
          amount: '6467571553831928182'
          metadata:
            network: EthereumSepolia
            name: Test
            symbol: Test
            decimals: 18
            tid: erc20:0xda0be7efd234295395d4204d0df4358339b57b27
        slippageBps: 100
        dateCreated: '2025-09-11T10:57:55.758Z'
        requestBody:
          quoteId: swapQuote-3hgv4-q8tbf-8v2ajmrbmg6m4i9t
          walletId: wa-3l3cj-l8mq7-8q78f9nopq7f1qjv
          targetWalletId: wa-3l3cj-l8mq7-8q78f9nopq7f1qjv
          provider: UniswapClassic
          slippageBps: 100
          sourceAsset:
            kind: Native
            amount: '10000000000'
          targetAsset:
            kind: Erc20
            contract: '0xda0be7efd234295395d4204d0df4358339b57b27'
            amount: '653003161'
        requester:
          userId: us-48r5q-eshfg-9pmr2lo6bmpr4i4i
          tokenId: to-4etah-smoal-9n3rmhul4dpaueg5
    Network:
      type: string
      title: Network
      enum:
        - Algorand
        - AlgorandTestnet
        - Aptos
        - AptosTestnet
        - ArbitrumOne
        - ArbitrumSepolia
        - ArcTestnet
        - AvalancheC
        - AvalancheCFuji
        - BabylonGenesis
        - BabylonTestnet5
        - Base
        - BaseSepolia
        - Berachain
        - BerachainBepolia
        - Bitcoin
        - BitcoinSignet
        - BitcoinTestnet3
        - BitcoinCash
        - Bob
        - BobSepolia
        - Bsc
        - BscTestnet
        - Canton
        - CantonTestnet
        - Cardano
        - CardanoPreprod
        - Concordium
        - ConcordiumTestnet
        - Celo
        - CeloAlfajores
        - Codex
        - CodexSepolia
        - CosmosHub4
        - CosmosIcsTestnet
        - Dogecoin
        - DogecoinTestnet
        - Ethereum
        - EthereumClassic
        - EthereumClassicMordor
        - EthereumSepolia
        - EthereumHolesky
        - EthereumHoodi
        - FantomOpera
        - FantomTestnet
        - FlareC
        - FlareCCoston2
        - FlowEvm
        - FlowEvmTestnet
        - Hedera
        - HederaTestnet
        - Ink
        - InkSepolia
        - InternetComputer
        - Ion
        - IonTestnet
        - Iota
        - IotaTestnet
        - Kaspa
        - Kusama
        - KusamaAssetHub
        - Litecoin
        - LitecoinTestnet
        - Near
        - NearTestnet
        - Optimism
        - OptimismSepolia
        - Origyn
        - Plasma
        - PlasmaTestnet
        - Plume
        - PlumeSepolia
        - Paseo
        - PaseoAssetHub
        - Polkadot
        - PolkadotAssetHub
        - Polygon
        - PolygonAmoy
        - Polymesh
        - PolymeshTestnet
        - Race
        - RaceSepolia
        - SeiAtlantic2
        - SeiPacific1
        - Solana
        - SolanaDevnet
        - Starknet
        - StarknetSepolia
        - Stellar
        - StellarTestnet
        - Sui
        - SuiTestnet
        - Tezos
        - TezosGhostnet
        - Tempo
        - TempoModerato
        - Tsc
        - TscTestnet1
        - Ton
        - TonTestnet
        - Tron
        - TronNile
        - Westend
        - WestendAssetHub
        - Xdc
        - XdcApothem
        - XLayer
        - XLayerSepolia
        - XrpLedger
        - XrpLedgerTestnet
    Requester:
      type: object
      properties:
        userId:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^us-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: User id.
          example: us-6b58p-r53sr-rlrd3l5cj3uc4ome
        tokenId:
          type: string
          minLength: 1
          maxLength: 64
          pattern: ^to-[a-z0-9]{5}-[a-z0-9]{5}-[a-z0-9]{14,16}$
          description: Token id.
          example: to-202a0-cdo33-o65mbt6q758lvvnt
      required:
        - userId
      description: The user who initiated the request.
  securitySchemes:
    authenticationToken:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        **Bearer Token:** Used to authenticate API requests.

        More details how to generate the token: [Authentication
        flows](https://docs.dfns.co/api-reference/auth/login-flows)

````